'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

require('regenerator-runtime/runtime');
var DataSourceManager = require('./DataSourceManager');
var Once = require('./utils/Once');

var Config = function () {
  function Config(dataSources) {
    _classCallCheck(this, Config);

    this.dataSourceManagers = [];
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = dataSources[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var dataSource = _step.value;

        this.dataSourceManagers.push(new DataSourceManager(dataSource, this));
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  }

  _createClass(Config, [{
    key: 'get',
    value: function get(key) {
      var _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, dataSourceManager, value;

      return regeneratorRuntime.async(function get$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _iteratorNormalCompletion2 = true;
              _didIteratorError2 = false;
              _iteratorError2 = undefined;
              _context.prev = 3;
              _iterator2 = this.dataSourceManagers[Symbol.iterator]();

            case 5:
              if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                _context.next = 17;
                break;
              }

              dataSourceManager = _step2.value;

              if (!dataSourceManager.initializing) {
                _context.next = 9;
                break;
              }

              return _context.abrupt('return', null);

            case 9:
              _context.next = 11;
              return regeneratorRuntime.awrap(dataSourceManager.get(key));

            case 11:
              value = _context.sent;

              if (!value) {
                _context.next = 14;
                break;
              }

              return _context.abrupt('return', value);

            case 14:
              _iteratorNormalCompletion2 = true;
              _context.next = 5;
              break;

            case 17:
              _context.next = 23;
              break;

            case 19:
              _context.prev = 19;
              _context.t0 = _context['catch'](3);
              _didIteratorError2 = true;
              _iteratorError2 = _context.t0;

            case 23:
              _context.prev = 23;
              _context.prev = 24;

              if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
              }

            case 26:
              _context.prev = 26;

              if (!_didIteratorError2) {
                _context.next = 29;
                break;
              }

              throw _iteratorError2;

            case 29:
              return _context.finish(26);

            case 30:
              return _context.finish(23);

            case 31:
              return _context.abrupt('return', null);

            case 32:
            case 'end':
              return _context.stop();
          }
        }
      }, null, this, [[3, 19, 23, 31], [24,, 26, 30]]);
    }
  }, {
    key: 'legacy',
    value: function legacy() {
      var _this = this;

      return {
        initialize: function initialize() {
          if (!_this.initialization) {
            _this.initialization = new Once(function _callee() {
              var _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _iterator3, _step3, dataSourceManager;

              return regeneratorRuntime.async(function _callee$(_context2) {
                while (1) {
                  switch (_context2.prev = _context2.next) {
                    case 0:
                      _iteratorNormalCompletion3 = true;
                      _didIteratorError3 = false;
                      _iteratorError3 = undefined;
                      _context2.prev = 3;
                      _iterator3 = _this.dataSourceManagers[Symbol.iterator]();

                    case 5:
                      if (_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done) {
                        _context2.next = 12;
                        break;
                      }

                      dataSourceManager = _step3.value;
                      _context2.next = 9;
                      return regeneratorRuntime.awrap(dataSourceManager.legacy().initialize());

                    case 9:
                      _iteratorNormalCompletion3 = true;
                      _context2.next = 5;
                      break;

                    case 12:
                      _context2.next = 18;
                      break;

                    case 14:
                      _context2.prev = 14;
                      _context2.t0 = _context2['catch'](3);
                      _didIteratorError3 = true;
                      _iteratorError3 = _context2.t0;

                    case 18:
                      _context2.prev = 18;
                      _context2.prev = 19;

                      if (!_iteratorNormalCompletion3 && _iterator3.return) {
                        _iterator3.return();
                      }

                    case 21:
                      _context2.prev = 21;

                      if (!_didIteratorError3) {
                        _context2.next = 24;
                        break;
                      }

                      throw _iteratorError3;

                    case 24:
                      return _context2.finish(21);

                    case 25:
                      return _context2.finish(18);

                    case 26:
                      _this.initializationDone = true;

                    case 27:
                    case 'end':
                      return _context2.stop();
                  }
                }
              }, null, _this, [[3, 14, 18, 26], [19,, 21, 25]]);
            });
          }
          return _this.initialization.do();
        },
        get: function get(key) {
          if (!_this.initializationDone) {
            throw Error('You must call Config.legacy().initialize() first before using legacyGet()');
          }

          var _iteratorNormalCompletion4 = true;
          var _didIteratorError4 = false;
          var _iteratorError4 = undefined;

          try {
            for (var _iterator4 = _this.dataSourceManagers[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
              var dataSourceManager = _step4.value;

              var value = dataSourceManager.legacy().get(key);
              if (value) {
                return value;
              }
            }
          } catch (err) {
            _didIteratorError4 = true;
            _iteratorError4 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion4 && _iterator4.return) {
                _iterator4.return();
              }
            } finally {
              if (_didIteratorError4) {
                throw _iteratorError4;
              }
            }
          }

          return null;
        }
      };
    }
  }]);

  return Config;
}();

;

module.exports = Config;
//# sourceMappingURL=Config.js.map