'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

require('regenerator-runtime/runtime');
var Credstash = require('nodecredstash');
var _ = require('lodash');

var CredstashDataSource = function () {
  function CredstashDataSource() {
    _classCallCheck(this, CredstashDataSource);
  }

  _createClass(CredstashDataSource, [{
    key: 'initialize',
    value: function initialize(config) {
      var stringToBool, loadingSecrets, credstash, i, key, secret, containingError;
      return regeneratorRuntime.async(function initialize$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return regeneratorRuntime.awrap(config.get('stage'));

            case 2:
              _context.t0 = _context.sent;
              this.table = [_context.t0, 'pay', 'credstash'].join('-');
              _context.next = 6;
              return regeneratorRuntime.awrap(config.get('aws.region'));

            case 6:
              this.region = _context.sent;
              _context.t1 = _;
              _context.t2 = require;
              _context.next = 11;
              return regeneratorRuntime.awrap(config.get('dir'));

            case 11:
              _context.t3 = _context.sent;
              _context.t4 = _context.t3 + '/creds.example.json';
              _context.t5 = (0, _context.t2)(_context.t4);
              this.keys = _context.t1.keys.call(_context.t1, _context.t5);
              _context.t6 = require('fs');
              _context.next = 18;
              return regeneratorRuntime.awrap(config.get('dir'));

            case 18:
              _context.t7 = _context.sent;
              _context.t8 = _context.t7 + '/creds.json';

              if (!_context.t6.existsSync.call(_context.t6, _context.t8)) {
                _context.next = 29;
                break;
              }

              _context.t10 = require;
              _context.next = 24;
              return regeneratorRuntime.awrap(config.get('dir'));

            case 24:
              _context.t11 = _context.sent;
              _context.t12 = _context.t11 + '/creds.json';
              _context.t9 = (0, _context.t10)(_context.t12);
              _context.next = 30;
              break;

            case 29:
              _context.t9 = null;

            case 30:
              this.defaults = _context.t9;
              _context.next = 33;
              return regeneratorRuntime.awrap(config.get('defaultSecrets'));

            case 33:
              this.secrets = _context.sent;
              _context.next = 36;
              return regeneratorRuntime.awrap(config.get('stage'));

            case 36:
              _context.t13 = _context.sent;

              if (!(_context.t13 !== 'dev')) {
                _context.next = 60;
                break;
              }

              stringToBool = function stringToBool(result) {
                return result === 'true' || result === 'false' ? result === 'true' : result;
              };

              loadingSecrets = {};
              credstash = new Credstash({
                table: this.table,
                awsOpts: {
                  region: this.region
                }
              });
              i = 0;

            case 42:
              if (!(i < this.keys.length)) {
                _context.next = 59;
                break;
              }

              key = this.keys[i];
              _context.prev = 44;
              _context.next = 47;
              return regeneratorRuntime.awrap(credstash.getSecret({ name: key }));

            case 47:
              secret = _context.sent;

              loadingSecrets[key] = stringToBool(secret);
              _context.next = 56;
              break;

            case 51:
              _context.prev = 51;
              _context.t14 = _context['catch'](44);
              containingError = new Error('Unable to load key "' + key + '" from credstash');

              containingError.originalError = _context.t14;
              throw containingError;

            case 56:
              i++;
              _context.next = 42;
              break;

            case 59:

              this.secrets = _.merge(this.secrets, loadingSecrets);

            case 60:
            case 'end':
              return _context.stop();
          }
        }
      }, null, this, [[44, 51]]);
    }
  }, {
    key: 'get',
    value: function get(key) {
      return _.get(this.secrets, key, null);
    }
  }]);

  return CredstashDataSource;
}();

module.exports = new CredstashDataSource();
//# sourceMappingURL=Credstash.js.map